#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <GL/gl.h>

void checkResult()
{
    GLenum err = glGetError();
    if (!err) {
        printf("Success!\n");
    } else switch(err) {
        case GL_INVALID_ENUM:
            printf("ERROR: GL_INVALID_ENUM\n");
            break;
        case GL_INVALID_VALUE:
            printf("ERROR: GL_INVALID_VALUE\n");
            break;
        case GL_INVALID_OPERATION:
            printf("ERROR: GL_INVALID_OPERATION\n");
            break;
        case GL_OUT_OF_MEMORY:
            printf("ERROR: GL_OUT_OF_MEMORY\n");
            break;
        case GL_INVALID_FRAMEBUFFER_OPERATION:
            printf("ERROR: GL_INVALID_FRAMEBUFFER_OPERATION\n");
            break;
        default:
            printf("Unknown Error!\n");
    }
}

int main(int argc, char **argv)
{
    GLuint vb;
    glGenBuffers(1, &vb);
    glBindBuffer(GL_ARRAY_BUFFER, vb);
    printf("Test glBufferData with INT32_MAX\n");
    glBufferData(GL_ARRAY_BUFFER, INT32_MAX, NULL, GL_STATIC_DRAW);
    checkResult();
    printf("Test glBufferData with INT32_MAX+1\n");
    glBufferData(GL_ARRAY_BUFFER, INT32_MAX+1, NULL, GL_STATIC_DRAW);
    checkResult();
    printf("Test glBufferData with UINT32_MAX\n");
    glBufferData(GL_ARRAY_BUFFER, UINT32_MAX, NULL, GL_STATIC_DRAW);
    checkResult();
    printf("Test glBufferData with UINT32_MAX+1\n");
    glBufferData(GL_ARRAY_BUFFER, UINT32_MAX+1, NULL, GL_STATIC_DRAW);
    checkResult();
    printf("Test glBufferData with INTPTR_MAX\n");
    glBufferData(GL_ARRAY_BUFFER, INTPTR_MAX, NULL, GL_STATIC_DRAW);
    checkResult();
    return 0;
}
